c	ABIBreakout.FOR
C	26-FEB-1997  David Mathog
C
C	This program opens an ABI trace file and then dumps fields
C	to a text format.
C	*****************************************************
c
	implicit none
	integer*4 MAXFILE
	parameter (MAXFILE=2**20)
	character*1 array(MAXFILE)   !A 1Mb array to hold the file
	character*120 infile,outfile, search
	integer flagsum
	parameter (flagsum=40)
	character*7 flagtypes(flagsum)
	integer*4 irec,brec,istat,incount,inlen,numstrings,ipoint
	integer*4 begin,length,step,swap,slen
	integer*4 inlenarray(10)
	integer*4 lastbyte
	integer*4 offset
	integer*4 action
c
	character*4 flag
	integer*4 datatype,datasize
	integer*4 instance,nrecords,nbytes,value
	integer*4 spare
c	
	byte sbyte(80,10)
	logical ok
c
	logical flagcompare
c
	data flagtypes/
	1                 ' tdir 0'  !jump to offset, no action
	1                ,' AEPt 1'  !immediate single value
	1                ,' ASPF 1'  !immediate single value
	1                ,' ASPt 1'  !immediate single value
	1                ,' AUTO 2'  !immediate multiple value
	1                ,' B1Pt 1'  !immediate single value
	1                ,' CAGT 2'  !immediate multiple value
	1                ,' CMBF 3'  !indirect multiple value
	1                ,' CMNT 3'  !indirect multiple value
	1                ,' CTTL 3'  !indirect multiple value
	1                ,' DATA 3'  !indirect multiple value
	1                ,' EVNT 3'  !indirect multiple value
	1                ,' FWO_ 2'  !immediate multiple value
	1                ,' GLEN 3'  !indirect multiple value
	1                ,' GELP 3'  !indirect multiple value
	1                ,' LANE 2'  !immediate multiple value
	1                ,' MCHN 3'  !indirect multiple value
	1                ,' MODL 2'  !immediate multiple value
	1                ,' MTRX 3'  !indirect multiple value
	1                ,' MTXF 3'  !indirect multiple value
	1                ,' NAVG 1'  !immediate single value
	1                ,' NCHn 1'  !immediate single value
	1                ,' NLNE 1'  !immediate single value
	1                ,' PBAS 3'  !indirect multiple value
	1                ,' PDMF 3'  !indirect multiple value
	1                ,' PLOC 3'  !indirect multiple value
	1                ,' PPOS 1'  !immediate single value
	1                ,' RSPN 1'  !immediate single value
	1                ,' RUND 1'  !immediate single value
	1                ,' RUNT 1'  !immediate single value
	1                ,' S/N% 3'  !indirect multiple value
	1                ,' SMPL 3'  !indirect multiple value
	1                ,' SPAC 6'  !immediate single value or indirect multiple value
	1                ,' SVER 5'  !immediate or indirect multiple value
	1                ,' THUM 4'  !indirect single value
	1                ,' TRKC 2'  !immediate multiple value
	1                ,' TRKI 1'  !immediate single value
	1                ,' TRKP 2'  !immediate multiple value
	1                ,' TRKP 2'  !immediate multiple value
	1                ,' drty 0'  !jump to offset, no action
	1/

	external flagcompare
c
c
c
	write(6,*)'ABIbreakout'
	write(6,*)' This program converts a binary ABI file to'
	write(6,*)' a text format.'
c
	write(6,*)' '
	write(6,*)'Input the name of the file to process'
	read(5,'(q,a)')inlen,infile(1:inlen)
c
	open(unit=10
	1 ,file=infile(1:inlen)
	1 ,form='UNFORMATTED',status='OLD'
	1 ,ORGANIZATION='SEQUENTIAL'
	1 ,RECORDTYPE='FIXED'
	1 ,READONLY,iostat=istat)
	if(istat.ne.0)stop 'Fatal error, something wrong with input file'

c
	inquire(10,RECL=irec)			!longwords, because unformmated
	if(irec.lt.0)then			!error...
	   stop 'ABIBreakout fatal error, illegal record size'
	else
	   brec=irec*4				!bytes/record
	   write(6,*)' '
	   write(6,*)'Each record is ',brec,' bytes long'
	end if
c
	   write(6,*)' '
	write(6,*)'Now reading in the input file'
	ipoint=1
	incount=0
	istat = 0
	do while(istat .ge. 0 .and. ipoint .le. MAXFILE - brec + 1)
	   call getrec(array(ipoint),irec*4,istat)
	   if(istat.eq.0)then
	      ipoint=ipoint+brec
	      incount = incount + 1
	   end if
	end do
	lastbyte = incount*brec
	write(6,*)' '
	write(6,*)'Read in ',incount,' records'
	write(6,*)'Read in ',lastbyte,' bytes'
	write(6,*)' '
	close(10)
c
	write(6,*)'Input the name of the output file'
	read(5,'(q,a)')inlen,infile(1:inlen)
	open(unit=11
	1 ,file=infile(1:inlen)
	1 ,form='FORMATTED',status='NEW'
	1 ,CARRIAGECONTROL='LIST'
	1 ,iostat=istat)
	if(istat.ne.0)stop 'Fatal error, something wrong with output file'
C
C	Determine if it is a MacBinary or not by the position of the ABIF
C	flag
C
	if(flagcompare(array(1),'ABIF'))then
	  offset = 1  !correction from file pointer to Fortran array pointers
	  ipoint = 7  !position of first FLAG structure
	else if(flagcompare(array(129),'ABIF'))then
	  offset = 129
	  ipoint = 135
	else
	  stop 'Fatal error - input file is not an ABI trace file'
	end if
	call getflag(array(ipoint)
	1  ,flag,instance,datatype,datasize,nrecords
	1  ,nbytes,value,spare,1)
	call getaction(flagtypes,flagsum,flag,instance,action)
	if(action .ne. 0)stop 'Fatal error, input file invalid'
	ipoint = offset + value
	action = 1
c
c
	do while(action .ne. 0)
	  call getflag(array(ipoint)
	1  ,flag,instance,datatype,datasize,nrecords
	1  ,nbytes,value,spare,0)
	  call getaction(flagtypes,flagsum,flag,instance,action)
C
C	Matrix overlays an odd,  signed integer 2 onto the unsigned
C	integer 2 datatype (4).  Make up a datatype for use in this
C	program that does not exist in ABI files
C
	  if(flag .eq. 'MTRX')datatype = 1004
	  call writefield(11, array,action, offset
	1    ,flag,instance,datatype,datasize
	1    ,nrecords,nbytes,value,spare)
	  ipoint = ipoint + 28
	end do
	close (11)
	
	stop 'ABIBreakout: normal completion' 
	end

	subroutine getrec(scratch,size,stat)
	implicit none
	integer*4 size,stat
	character*1 scratch(size)
	read(10,iostat=stat)scratch
	return
	end

	subroutine tellem(array,begin,length,step,swap)
	implicit none
	integer*4 begin,length,step,swap,i,j,k
	byte array(*)
	byte ba(4),btemp
	integer*2 wa(2),wtemp
	integer*4 la, longword
	integer*4   sbyte,sword
	integer*4   ubyte,uword
	character*2 outc
	equivalence (ba,wa,la)
c
	write(6,2000)'*******************************************************************************'
	write(6,2000)'|-Abs-Position--|-Rel-Position--|---byte-----|---word----------------|-----longword-------|char|'
	write(6,2000)'    int      hex     int      hex int uint hex         int        uint         int      hex'
	do i =begin,begin+length-1,step
c
c	load the 4 bytes into the equivalenced byte array
c
	  k = i
	  do j=1,4
	    ba(j)=array(k)
	    k = k + 1
	  end do
c
c	pull off the byte and unsigned byte
c
	sbyte=ba(1)
	ubyte=jiand('ff'x,la)
c
c	pull off the word and unsigned word
c
	sword=wa(1)
	uword=jiand('ffff'x,la)
c
c	pull off the longword
c
	longword=la
c
c	swap as needed
c
	if(swap .eq. 1)then
c
	   la = uword
	   btemp=ba(1)
	   ba(1)=ba(2)
	   ba(2)=btemp
	   uword=la
c
	   la = sword
	   btemp=ba(1)
	   ba(1)=ba(2)
	   ba(2)=btemp
	   sword=wa(1)
c
	   la = longword
	   do j = 0,1
	     btemp=ba(4-j)
	     ba(4-j)=ba(j+1)
	     ba(j+1)=btemp
	   end do
	   longword=la
	end if
c
c
	if(ubyte .ge. '40'o .and. ubyte .le. '177'o)then
	  outc=char(ubyte)
	  if(ubyte .eq.'40'o)outc='SP'
	else
	  outc='**'
	endif
	write(6,1000)i,i,i-begin,i-begin,sbyte,ubyte,ubyte,sword,uword,
	1      longword,longword,outc
	end do

1000	format(2(' ',i7,' ',z8),2(' ',i4),' ',z2,3(' ',i11),' ',z8,' ',a)
2000	format(' ',a)
	return
	end

	logical function flagcompare(array,text)
	implicit none
	character*1    array(4)
	character*4    text
c
	integer i
c
	flagcompare = .true.
	do i = 1,4
	  if(array(i) .ne. text(i:i))then
	     flagcompare = .false.
	     return
	  end if
	end do
	return
	end

	subroutine getflag(array
	1  ,flag,instance,datatype,datasize,nrecords
	1  ,nbytes
	1  ,value
	1  ,spare,swap)
	implicit none
c
	character*1 array(28)
	character*4 flag
	integer*4 datatype,datasize
	integer*4 instance,nrecords,nbytes
	integer*4 value
	integer*4 spare,swap
c
	integer*4 i
c
	character*1 ca(4)
	byte        ba(4)
	integer*2   wa(2)
	integer*4   la
	real*4      ra     
	equivalence (ca,ba,wa,la)
c
c	extract flag
c
	do i = 1,4
	  flag(i:i) = array(i)
	end do
c
c	extract instance
c
	do i = 1,4
	  ca(i)=array(9-i)
	end do
	instance = la
c
c	extract datatype and datasize
c
	do i = 1,4
	  ca(i)=array(13-i)
	end do
	datatype=wa(2)
	datasize=wa(1)
c
c	extract Nrecords
c
	do i = 1,4
	  ca(i)=array(17-i)
	end do
	nrecords = la
c
c	extract Nbytes
c
	do i = 1,4
	  ca(i)=array(21-i)
	end do
	nbytes = la
c
c	extract value - swap or not depend on SWAP
c
	if(swap .eq. 1)then
	  do i = 1,4
	    ca(i)=array(25 - i)
	  end do
	else
	  do i = 1,4
	    ca(i)=array(20+i)
	  end do
	end if
	value = la
c
c	extract spare
c
	do i = 1,4
	  ca(i)=array(29-i)
	end do
	spare = la
c
	return
	end

	subroutine getaction(flagtypes,num,flag,instance,action)
	implicit none
	integer*4     action,num,instance
	character*4   flag
	character*7 flagtypes(num)
c
	integer*4 i,k
c
	do i = 1,num
	  k = index(flagtypes(i),flag)
	  if(k .ne. 0)then
	     action = ichar(flagtypes(i)(7:7))  - ichar('0')
c
c	The SVER field is screwy, the first instance is IMMEDIATE MULTIPLE
c	and the second instance is INDIRECT MULTIPLE.  Blame ABI
c	for some silly programming.
c
	     if(action .eq. 5)then
	        if(instance .eq. 1)then
	           action = 2
	        else
	           action = 3
	        end if
	     end if
c
c	The SPAC field is screwy, the first instance is IMMEDIATE SINGLE
c	and the second instance is INDIRECT MULTIPLE with a completely 
c	different data type, and the third is back to IMMEDIATE SINGLE 
c	again.  Blame ABI for some silly programming.
c
	     if(action .eq. 6)then
	        if(instance .eq. 2)then
	           action = 3
	        else
	           action = 1
	        end if
	     end if
c
	     return
	  end if	  
	end do
	action = -1
c
	return
	end


	subroutine writefield(unit, array,action, offset
	1    ,flag,instance,datatype,datasize,nrecords
	1    ,nbytes,value,spare)
	implicit none
c
	character*1 array(1)
	integer*4 unit,action,offset
	integer*4 instance,datatype,datasize
	integer*4 nrecords, nbytes
	integer*4 value,spare
	character*4 flag
c
	real*4    rtemp
	integer*4 i,k,ipoint
	logical novel
c
	character*1 ca(4)
	byte        ba(4),btemp
	integer*2   wa(2)
	integer*4   la
	real*4      ra     
	equivalence (ca,ba,wa,la,ra)
c
c	perform the appropriate action.  If action <=0 nothing happens
c
	novel = .false.
	if(action .eq. 1)then  !immediate single value
	  la = value
	  if(datatype .eq. 2)then
	    write(unit,1002)flag,instance,value
	  else if(datatype .eq. 4)then
	    btemp=ba(2)
	    ba(2)=ba(1)
	    ba(1)=btemp
	    write(unit,1004)flag,instance,wa(1)
	  else if(datatype .eq. 7)then
	    do i = 1,2
	      btemp = ba(5-i)
	      ba(5-i) = ba(i)
	      ba(i) = btemp
	    end do
	    write(unit,1007)flag,instance,ra
	  else if(datatype .eq. 10)then
	    btemp=ba(2)
	    ba(2)=ba(1)
	    ba(1)=btemp
	    write(unit,1010)flag,instance,wa(1),ba(3),ba(4)
	  else if(datatype .eq. 11)then
	    write(unit,1011)flag,instance,ba(1),ba(2),ba(3)
	  else if(datatype .eq. 18)then
	    i = ichar(ca(1))+1
	    k = 2
	    write(unit,1018)flag,instance,(ba(k),k=2,i)
	  else
	    novel = .true.
	  end if
	else if(action .eq. 2)then !immediate multiple value
	  la = value
	  if(datatype .eq. 2)then
	    write(unit,1002)flag,instance,value
	  else if(datatype .eq. 4)then
	    do i = 1,2
	      btemp = ba(5-i)
	      ba(5-i) = ba(i)
	      ba(i) = btemp
	    end do
	    write(unit,2004)flag,instance,wa(1),wa(2)
	  else if(datatype .eq. 13)then
	    i = nbytes
	    write(unit,2013)flag,instance,(ba(i),k=1,i)
	  else if(datatype .eq. 18)then
	    k = jiand('ff'x,value)
	    la = value
	    write(unit,3018)flag,instance,(  ca(i),i=2,1+k)
	  else
	    novel = .true.
	  end if
	else if(action .eq. 3)then !indirect multiple value
	  la = value  ! always an offset into the file
	  do i = 1,2
	    btemp = ba(5-i)
	    ba(5-i) = ba(i)
	    ba(i) = btemp
	  end do
	  ipoint = la + offset !now we know where in the array
c
	  if(datatype .eq. 2)then
	    if(ipoint .ne. offset)then
	      write(unit,3002)flag,instance,(array(i),i=ipoint,ipoint+nbytes-1)
	    else
	      write(unit,1002)flag,instance,'NONE'
	    end if
	  else if(datatype .eq. 4)then
	    wa(2)=0
	    if(ipoint .ne. offset)then
	      write(unit,3004)flag,instance
	      do i = 1, nrecords
	        ca(2)=array(ipoint)
	        ipoint = ipoint + 1
	        ca(1)=array(ipoint)
	        ipoint = ipoint + 1
	        write(unit,30045)i,la
	      end do
	    else
	      write(unit,1002)flag,instance,'NONE'
	    endif
	  else if(datatype .eq. 1004)then
	    wa(2)=0
	    if(ipoint .ne. offset)then
	      write(unit,3004)flag,instance
	      do i = 1, nrecords
	        ca(2)=array(ipoint)
	        ipoint = ipoint + 1
	        ca(1)=array(ipoint)
	        ipoint = ipoint + 1
	        rtemp = float(wa(1))/1000.
	        write(unit,30046)i,rtemp
	      end do
	    else
	      write(unit,1002)flag,instance,'NONE'
	    endif
	  else if(datatype .eq. 18)then
	    if(ipoint .ne. offset)then
	      write(unit,3018)flag,instance,(array(i),i=ipoint+1,ipoint+nbytes-1)
	    else
	      write(unit,1002)flag,instance,'NONE'
	    end if
	  else
	    novel = .true.
	  end if
	else if(action .eq. 4)then !indirect single value
	  la = value  ! always an offset into the file
	  do i = 1,2
	    btemp = ba(5-i)
	    ba(5-i) = ba(i)
	    ba(i) = btemp
	  end do
	  ipoint = la + offset !now we know where in the array
c
	  if(datatype .eq. 12)then  !THUM structures
	    write(unit,4012)flag,instance,(ichar(array(i)),i=ipoint,ipoint+9)
	  else
	    novel = .true.
	  end if
	end if
c
	if(novel)then
	    write(6,9000)flag,instance,datatype,datasize
	1        ,nrecords,nbytes,value,spare
	end if

9000	format(' Novel FLAG structure encountered',/
	1      ' FLAG:        ',a4,/
	1      '  instance   ',i6,/
	1      '  datatype   ',i6,/
	1      '  datasize   ',i6,/
	1      '  nrecords   ',i6,/
	1      '  nbytes     ',i6,/
	1      '  value(hex) ',z8,/
	1      '  spare(hex) ',z8)

1002	format('>',a4,i6,' ',a4)
1004	format('>',a4,i6,' ',i6)
1007	format('>',a4,i6,' ',f9.3)
1010	format('>',a4,i6,' ',i6,'(y)',i3,'(m)',i3,'(d)')
1011	format('>',a4,i6,' ',i6,'(h)',i3,'(m)',i3,'(s)')
1018	format('>',a4,i6,' ',a4)
2004	format('>',a4,i6,2(' ',i6))
2013	format('>',a4,i6,4(' ',z6))
3002	format('>',a4,i6,' ',/,5000(50a,/))
3004	format('>',a4,i6, '(Pos,Value)')
30045	format('   ',i6,',',i6)
30046	format('   ',i6,',',f7.3)
3018	format('>',a4,i6,' ',256a)
4012	format('>',a4,i6,' ',z2,9(',',z2))

	return
	end
